#property copyright "Lorentzos Roussos 2020"
#property link      "https://www.mql5.com/en/users/lorio"
#property strict
enum unite_type
{
unite_void=-1,//VOID
unite_uchar=0,//UCHAR
unite_char=1,//CHAR
unite_ushort=2,//USHORT
unite_short=3,//SHORT
unite_uint=4,//UINT
unite_int=5,//INT
unite_ulong=6,//ULONG
unite_long=7,//LONG
unite_float=8,//FLOAT
unite_double=9,//DOUBLE
unite_datetime=10//DATETIME
};
union unite_data
{
public:
uchar Uchar;
char Char;
ushort Ushort;
short Short;
uint Uint;
int Int;
ulong Ulong;
long Long;
float Float;
double Double;
datetime Datetime;
unite_data(void){}
template<typename U>
unite_type SetData(U &data)
           {
           if(typename(data)=="uchar"){Uchar=(uchar)data;return(unite_uchar);}
           if(typename(data)=="char"){Char=(char)data;return(unite_char);}
           if(typename(data)=="ushort"){Ushort=(ushort)data;return(unite_ushort);}
           if(typename(data)=="short"){Short=(short)data;return(unite_short);}
           if(typename(data)=="uint"){Uint=(uint)data;return(unite_uint);}
           if(typename(data)=="int"){Int=(int)data;return(unite_int);}
           if(typename(data)=="ulong"){Ulong=(ulong)data;return(unite_ulong);}
           if(typename(data)=="long"){Long=(long)data;return(unite_long);}
           if(typename(data)=="float"){Float=(float)data;return(unite_float);}
           if(typename(data)=="double"){Double=(double)data;return(unite_double);}
           if(typename(data)=="datetime"){Datetime=(datetime)data;return(unite_datetime);}
           return(unite_void);
           }
template<typename U>
void GetData(U &data)
     {
     if(typename(data)=="uchar"){data=Uchar;return;}
     if(typename(data)=="char"){data=Char;return;}
     if(typename(data)=="ushort"){data=Ushort;return;}
     if(typename(data)=="short"){data=Short;return;}
     if(typename(data)=="uint"){data=Uint;return;}
     if(typename(data)=="int"){data=Int;return;}
     if(typename(data)=="ulong"){data=Ulong;return;}
     if(typename(data)=="long"){data=Long;return;}
     if(typename(data)=="float"){data=Float;return;}
     if(typename(data)=="double"){data=Double;return;}
     if(typename(data)=="datetime"){data=Datetime;return;}
     }           
};
struct unite
{
private:
unite_type Type;
unite_data Data;
int DataDigits;
string Name,TAG_DECALL,preFix,sufFix;
public:
unite(void){ulong max=ULONG_MAX;Data.SetData(max);Type=unite_void;DataDigits=Digits();Name=NULL;TAG_DECALL=NULL;preFix=NULL;sufFix=NULL;}
template<typename U>
void SetData(U &data){Type=Data.SetData(data);}
template<typename U>
void GetData(U &result){Data.GetData(result);}
void SetDigits(int d){DataDigits=d;}
string DataText()
       {
       if(Type==unite_uchar){return(preFix+IntegerToString(Data.Uchar)+sufFix);}
       if(Type==unite_char){return(preFix+IntegerToString(Data.Char)+sufFix);}
       if(Type==unite_ushort){return(preFix+IntegerToString(Data.Ushort)+sufFix);}
       if(Type==unite_short){return(preFix+IntegerToString(Data.Short)+sufFix);}
       if(Type==unite_uint){return(preFix+IntegerToString(Data.Uint)+sufFix);}
       if(Type==unite_int){return(preFix+IntegerToString(Data.Int)+sufFix);}
       if(Type==unite_ulong){return(preFix+IntegerToString(Data.Ulong)+sufFix);}
       if(Type==unite_long){return(preFix+IntegerToString(Data.Long)+sufFix);}
       if(Type==unite_float){return(preFix+DoubleToString(Data.Float,DataDigits)+sufFix);}
       if(Type==unite_double){return(preFix+DoubleToString(Data.Double,DataDigits)+sufFix);}
       if(Type==unite_datetime){return(preFix+TimeToString(Data.Datetime,TIME_DATE|TIME_MINUTES|TIME_SECONDS)+sufFix);}
       return("");
       }
unite_type GetType(){return(Type);}
void Setup(string name,string prefix,string suffix){Name=name;preFix=prefix;sufFix=suffix;TAG_DECALL=name;bool u=StringToUpper(TAG_DECALL);}
string TagName(){return(TAG_DECALL);}
};
class special_hline
{
                  //private by default
bool              IsDisplayed,HasTag,IsSetup,TagLineSameColor,Visible;
string            ObjTether,TagTether,Name,TagText,TagFont,TagSuffix,ObjPrefix;
double            Price,PreviousPrice;
color             LineColor,TagColor;
ENUM_LINE_STYLE   LineStyle;
long              ChartId;
int               Digs,Origin,LineWidth,TagFontSize,SubW,TagBarOffset;
ENUM_ANCHOR_POINT TagAnchor;
datetime          TagTime;
                  public:
                  special_hline(void);
                  ~special_hline(void);
void              Reset(bool);
void              Show();
void              Hide();
void              Display();
void              Setup(long,int,string,string,double,color,ENUM_LINE_STYLE,int,bool);
void              TagSetup(string,string,int,color,ENUM_ANCHOR_POINT,int,string,bool);

void              DataUpdate(double,bool,bool);
void              DataUpdate(double,string,bool,bool);
double            GetPrice();
void              StyleUpdate(color,ENUM_LINE_STYLE,int,color,ENUM_ANCHOR_POINT,bool,bool);
void              SetOrigin(int);
void              SetDigits(int);
                  private:
string            ProcessTag(string);
                  //change tracker
bool              ct_move,ct_lin_color,ct_lin_width,ct_lin_style,ct_tag_color,ct_tag_anchor,ct_tag_text; 
void              ct_reset();     
                  //extended tag data - double
unite             ETD[];                      
                  //etd methods 
                  public:
void              ETDAdd(string,string,string);
                  template<typename U>
void              ETDAdd(string,string,string,U&);
                  template<typename U>
void              ETDAdd(string,string,string,U&,int);
                  template<typename U>
void              ETDUpdate(string,U&,bool,bool);
                  template<typename U>   
void              ETDUpdate(int,U&,bool,bool);               
};
special_hline::special_hline(void){Reset(true);}
special_hline::~special_hline(void){Reset(true);}
//Setup 
void special_hline::Setup(long chart_id,
                          int subwindow,
                          string line_prefix,
                          string name,
                          double price,
                          color line_color,
                          ENUM_LINE_STYLE line_style,
                          int line_width,
                          bool setup_done){
Reset(true);  
ChartId=chart_id;
SubW=subwindow;
Name=name;
ObjTether=name;
if(line_prefix!=NULL){ObjPrefix=line_prefix;ObjTether=line_prefix+name;}
Price=price;PreviousPrice=price;
LineColor=line_color;
LineStyle=line_style;
LineWidth=line_width;      
if(HasTag){TagTether=ObjTether+"_"+TagSuffix;if(LineColor==TagColor){TagLineSameColor=true;}}
if(setup_done){IsSetup=true;}          
}
//TagSetup
void special_hline::TagSetup(string font,
                             string tag_suffix,
                             int font_size,
                             color text_color,
                             ENUM_ANCHOR_POINT text_anchor,
                             int bar_offset,
                             string text,
                             bool setup_done){
HasTag=true;
TagSuffix=tag_suffix;
if(Name!=NULL){TagTether=ObjTether+"_"+TagSuffix;} 
TagFont=font;
TagFontSize=font_size;
TagColor=text_color;
if(TagColor==LineColor){TagLineSameColor=true;}
TagAnchor=text_anchor;
TagBarOffset=bar_offset;
TagText=text;
if(setup_done){IsSetup=true;}                
}
//Reset
void special_hline::Reset(bool delete_objects){
if(delete_objects){ObjectDelete(ChartId,ObjTether);ObjectDelete(ChartId,TagTether);}
IsDisplayed=false;HasTag=false;IsSetup=false;TagLineSameColor=false;Visible=false;
ObjTether=NULL;TagTether=NULL;Name=NULL;TagText=NULL;TagFont=NULL;ObjPrefix=NULL;TagSuffix=NULL;
TagBarOffset=0;
Origin=0;Digs=Digits();
ArrayFree(ETD);
}
double special_hline::GetPrice(){return(Price);}
//Data updates : 
void special_hline::DataUpdate(double new_price,
                               bool update_displays,
                               bool reset_trackers){
if(reset_trackers) ct_reset();
ct_move=true;ct_tag_text=true;
PreviousPrice=Price;                              
Price=new_price;
if(update_displays){Display();}
}
void special_hline::DataUpdate(double new_price,
                               string new_tag,
                               bool update_displays,
                               bool reset_trackers){
if(reset_trackers) ct_reset();
ct_move=true;
ct_tag_text=true;
PreviousPrice=Price;                               
Price=new_price;
TagText=new_tag;
if(update_displays){Display();}
}
void special_hline::StyleUpdate(color new_line_color,
                                ENUM_LINE_STYLE new_line_style,
                                int new_line_width,
                                color new_tag_color,
                                ENUM_ANCHOR_POINT new_tag_anchor,
                                bool update_displays,
                                bool reset_trackers){
if(reset_trackers) ct_reset();
if(new_line_color!=clrNONE){LineColor=new_line_color;ct_lin_color=true;}
if(new_line_style!=EMPTY){LineStyle=new_line_style;ct_lin_style=true;}
if(new_tag_color!=clrNONE){TagColor=new_tag_color;ct_tag_color=true;}
if(new_tag_anchor!=EMPTY){TagAnchor=new_tag_anchor;ct_tag_anchor=true;}
if(new_line_width!=NULL){LineWidth=new_line_width;ct_lin_width=true;}      
if(update_displays){Display();}                          
}
//Show
void special_hline::Show(){
if(IsDisplayed&&!Visible)
{
ObjectSetInteger(ChartId,ObjTether,OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
if(HasTag)
  {
  ObjectSetInteger(ChartId,TagTether,OBJPROP_TIMEFRAMES,OBJ_ALL_PERIODS);
  }
Visible=true;
}
if(!IsDisplayed){Display();}
}
//Hide
void special_hline::Hide(){
if(!IsDisplayed){Visible=false;}
if(IsDisplayed&&!Visible){
ObjectSetInteger(ChartId,ObjTether,OBJPROP_TIMEFRAMES,OBJ_NO_PERIODS);
if(HasTag)
  {
  ObjectSetInteger(ChartId,TagTether,OBJPROP_TIMEFRAMES,OBJ_NO_PERIODS);
  }
Visible=false;
}
}
//Display
void special_hline::Display()
{
if(!IsSetup){Print(__FUNCSIG__+" Line not setup ,file : "+__FILE__+" line :"+IntegerToString(__LINE__));}
//if its setup and displayed - displayed stands for created ever in this compilation
if(IsSetup&&IsDisplayed)
{
//moved 
  if(ct_move)
  {
  ObjectSetDouble(ChartId,ObjTether,OBJPROP_PRICE,Price);
  if(HasTag){ObjectSetDouble(ChartId,TagTether,OBJPROP_PRICE,Price);}
  }
//line color
  if(ct_lin_color){ObjectSetInteger(ChartId,ObjTether,OBJPROP_COLOR,LineColor);}
//line width
  if(ct_lin_width){ObjectSetInteger(ChartId,ObjTether,OBJPROP_WIDTH,LineWidth);}
//line style
  if(ct_lin_style){ObjectSetInteger(ChartId,ObjTether,OBJPROP_STYLE,LineStyle);}
//tag text 
  if(ct_tag_text&&HasTag){ObjectSetString(ChartId,TagTether,OBJPROP_TEXT,ProcessTag(TagText));}
//tag anchor 
  if(ct_tag_anchor&&HasTag){ObjectSetInteger(ChartId,TagTether,OBJPROP_ANCHOR,TagAnchor);}
//tag color 
  if(ct_tag_color&&HasTag){ObjectSetInteger(ChartId,TagTether,OBJPROP_COLOR,TagColor);}
}
//if its setup and displayed ends here
//if its setup and not displayed yet - displayed stands for created ever in this compilation
if(IsSetup&&!IsDisplayed)
{
bool object=true,tag=true;
//object 
object=ObjectCreate(ChartId,ObjTether,OBJ_HLINE,SubW,Time[Origin],Price);
//if created 
  if(object)
  {
  ObjectSetInteger(ChartId,ObjTether,OBJPROP_COLOR,LineColor);
  ObjectSetInteger(ChartId,ObjTether,OBJPROP_STYLE,LineStyle);
  ObjectSetInteger(ChartId,ObjTether,OBJPROP_WIDTH,LineWidth);
    //if we also need a tag 
    if(HasTag)
    {
    int tag_offset=Origin+TagBarOffset;
    datetime tod=0;
    if(tag_offset>=0&&tag_offset<Bars){tod=Time[tag_offset];}
    if(tag_offset<0){tag_offset=(-1)*tag_offset;tod=(datetime)(Time[0]+PeriodSeconds(_Period)*tag_offset);}
    tag=ObjectCreate(ChartId,TagTether,OBJ_TEXT,SubW,tod,Price);
      //and we get a tag 
      if(tag)
      {
      ObjectSetInteger(ChartId,TagTether,OBJPROP_ANCHOR,TagAnchor);
      ObjectSetInteger(ChartId,TagTether,OBJPROP_COLOR,TagColor);
      ObjectSetInteger(ChartId,TagTether,OBJPROP_FONTSIZE,TagFontSize);
      ObjectSetString(ChartId,TagTether,OBJPROP_FONT,TagFont);
      ObjectSetString(ChartId,TagTether,OBJPROP_TEXT,ProcessTag(TagText));
      }
      //and we get a tag ends here
    }
    //if we also need a tag ends here 
  }
  //if created ends here 
IsDisplayed=object&&tag;
Visible=true;
}
//if its setup and not displayed yet ends here
}
void special_hline::ct_reset(void){
ct_lin_color=false;
ct_lin_style=false;
ct_lin_width=false;
ct_move=false;
ct_tag_anchor=false;
ct_tag_color=false;
ct_tag_text=false;
}
void special_hline::SetDigits(int d){Digs=d;Display();}

//Etd Add ,no type 
void special_hline::ETDAdd(string name,string prefix,string suffix){
int newsize=ArraySize(ETD)+1;
ArrayResize(ETD,newsize,0);
ETD[newsize-1].Setup(name,prefix,suffix);
}
//Etd Add Type
template<typename U>
void special_hline::ETDAdd(string name,string prefix,string suffix,U &value){
int newsize=ArraySize(ETD)+1;
ArrayResize(ETD,newsize,0);
ETD[newsize-1].Setup(name,prefix,suffix);
ETDUpdate(newsize-1,value,false,false);
}

//Etd Add Type
template<typename U>
void special_hline::ETDAdd(string name,string prefix,string suffix,U &value,int digits){
int newsize=ArraySize(ETD)+1;
ArrayResize(ETD,newsize,0);
ETD[newsize-1].Setup(name,prefix,suffix);
ETDUpdate(newsize-1,value,false,false);
ETD[newsize-1].SetDigits(digits);
}
//Etd Update data by name of ETD (extensible tag data)
template<typename U>
void special_hline::ETDUpdate(string name,
                              U &new_value,
                              bool update_displays,
                              bool reset_trackers){
if(reset_trackers) ct_reset();
//if etds exist 
if(ArraySize(ETD)>0)
{
string tagfind=name;
bool u=StringToUpper(tagfind);
for(int e=0;e<ArraySize(ETD);e++)
   {
   if(ETD[e].TagName()==tagfind)
     {
     //ETD[e].SetValue(new_value);
     ETD[e].SetData(new_value);
     ct_tag_text=true;
     break;
     }
   }
}
//if etds exist ends here
if(update_displays){Display();}
}
//Etd Update data by name of ETD (extensible tag data)
template<typename U>
void special_hline::ETDUpdate(int ix,
                              U &new_value,
                              bool update_displays,
                              bool reset_trackers){
if(reset_trackers) ct_reset();
//if etds exist 
if(ix<=(ArraySize(ETD)-1))
{
     ETD[ix].SetData(new_value);
     ct_tag_text=true;
}
//if etds exist ends here
if(update_displays){Display();}
}
string special_hline::ProcessTag(string feed){
  //name instances 
  if(StringFind(feed,"{NAME}",0)!=-1)
  {
  int r=StringReplace(feed,"{NAME}",Name);
  }
  //price instances ,hotphrase :: {PRICE} 
  if(StringFind(feed,"{PRICE}",0)!=-1)
  {
  string swap=DoubleToString(Price,Digs);
  int r=StringReplace(feed,"{PRICE}",swap);
  }
  //price previous ,hotphrase  :: {PREVIOUS_PRICE}
  if(StringFind(feed,"{PREVIOUS_PRICE}",0)!=-1)
  {
  string swap=DoubleToString(PreviousPrice,Digs);
  int r=StringReplace(feed,"{PREVIOUS_PRICE}",swap);
  }
  //etd's
  if(ArraySize(ETD)>0)
    {
    for(int e=0;e<ArraySize(ETD);e++)
       {
       string fi="{"+ETD[e].TagName()+"}";
       if(StringFind(feed,fi,0)!=-1)
         {
         string swap=ETD[e].DataText();
         int r=StringReplace(feed,fi,swap);
         }
       }
    }
  //etd's end here
return(feed);
}
